/* 
Typing Tiles
(c)2009 Joanna Mueller

Panel game created for the June 2009 3DGS new user contest. My very first attempt
at using any scripting language with only a few weeks experience. 
*/
///////////////////
#include <acknex.h>
#include <default.c>
//////////////////////////////////////////////////////////////////////The variables
var level = 1;
var dice;
var roller =1;
var correct = 0;
var missed = 0;
var score = 0;
var speed =50;
var accuracy;
var lives =3;
var difficulty;
var volume = 45;
var images;
var noise;
STRING* acc = "    ";
//////////////////////////////////////////////////////////////////////The text
STRING* acc = "    ";
STRING* champion ="Typing Champion!";
STRING* expert ="Typing Expert!";
STRING* great ="Great Work!";
STRING* good = "Good Job!";
STRING* try = "Keep Trying";
//////////////////////////////////////////////////////////////////////The sounds
SOUND* blockskip = "laser_1.wav";
SOUND* blockmiss = "alarm_2.wav";
SOUND* blockcorrect = "cork_pop.wav";
SOUND* levelsignal1 = "yeehaaa.wav";
SOUND* levelsignal2 = "yaahooo.wav";
SOUND* levelsignal3 = "yipee.wav";
SOUND* freelife = "nice_effect.ogg";
//////////////////////////////////////////////////////////////////////Background music
var firstmusic;
var secondmusic;
var thirdmusic;
var fourthmusic;
var fifthmusic;
var sixthmusic;
var seventhmusic;
var eighthmusic;
var ninethmusic;
var tenthmusic;
var winnermusic;
var losermusic;
var intromusic;
/////////////////////////////////////////////////////////////////////////Opening sequence
BMAP* title = "titlescreen.pcx";
PANEL* intro1 =
{
	pos_x = 100;
	pos_y = 100;
	bmap = title;
	flags = SHOW | OVERLAY;
}
//////////////////////////////////////////////////////////////////////////Button Functions
function quit_program()///
{
	while (key_any) {wait (1);}
	sys_exit(NULL);
}
/////////////////////////////////////
function easy_setting()
{
	lives=5;
	speed=40;
}
function medium_setting()
{
	lives=3;	
	speed=50;
}
function hard_setting()
{
	lives=1;
	speed=60;
}
//////////////////////////////////////
function no_background()
{
	images = 1 - images;
}
function no_soundfx()
{
	noise =1 - noise;
}
/////////////////////////////////////
BMAP* instructions = "introscreen.pcx";///Second screen of the game
PANEL* intro2 =
{
	bmap = instructions;
	pos_x = 0;
	pos_y = 0;
	button (71,468, "playclicked.pcx", "playnormal.pcx", "playover.pcx", gamestart(), NULL, NULL);
	button (304,468, "noclicked.pcx", "nonormal.pcx", "noover.pcx",quit_program, NULL, NULL);
	button (614,501, "optionkeyclicked.pcx", "optionkey.pcx", "optionkeyover.pcx", open_options(), NULL, NULL);
	button_radio (614,72, "diffeasyselected.pcx", "diffeasy.pcx", "diffeasyover.pcx", easy_setting(),NULL,NULL;
	button_radio (614,144, "diffmediumselected.pcx", "diffmedium.pcx", "diffmediumover.pcx", medium_setting(), NULL, NULL);
	button_radio (614,217, "diffhardselected.pcx", "diffhard.pcx", "diffhardover.pcx", hard_setting(), NULL, NULL);
}
/////////////////////////////////////
BMAP* options = "optionsscreen.pcx";///options menu
PANEL* gameoptions1 =
{
	bmap =options;
	layer =2;
	pos_x = 60;
	pos_y = 60;
	button_toggle (419,80, "optionoff.pcx", "optionon.pcx", "optionoffnull.pcx", "optiononnull.pcx", no_background(), NULL, NULL);
	button_toggle (419,147, "optionoff.pcx", "optionon.pcx", "optionoffnull.pcx", "optiononnull.pcx", no_soundfx(), NULL, NULL);
	hslider (166,305,237,"sliderbar.bmp",1,90,volume);
	button (508,352, "optionsdoneclicked.bmp", "optionsdone.bmp", "optionsdoneover.bmp", close_options(), NULL, NULL);
}
/////////////////////////////////////
function open_options()///options menu functions
{
gameoptions1.flags = SHOW;	
}
function close_options()
{
gameoptions1.flags = 0;
}
//////////////////////////////////////////////////////////////////////The gameboard
BMAP* gameover = "gameover.pcx";
PANEL* final_screen =
{
	bmap = gameover;
	layer = 3;
	button (224,429,"goagainclicked.pcx", "goagain.pcx", "goagainover.pcx", restartlose(), NULL, NULL);
	button (420, 429, "goquitclicked.pcx", "goquit.pcx", "goquitover.pcx", quit_program(), NULL, NULL);
	digits (196, 357,6, "Arial#40b", 1, score);
}
TEXT* acc_txt=
{
	layer=4;
	pos_x = 597;
	pos_y =357;
	font= Arial#40b;
	string(acc);
}
/////////////////////////////////////
BMAP* level_interface = "interface.pcx";
PANEL* first_level =
{
	bmap = level_interface;
	layer = 2;
	digits (15, 32, 2, "Arial#35b", 1, level);
	digits (720, 62, 2, "Arial#35b", 1, lives);
	digits (720, 204, 3, "Arial#35b", 1, correct);
	digits (720, 356,3, "Arial#35b", 1, missed);
	digits (720, 491, 4, "Arial#35b", 1, score);
}
BMAP* go_youwin ="winscreen.bmp";
PANEL* gameover_win =
{
 bmap =go_youwin;
 button(46,488,"playagainclicked.pcx", "playagainnormal.pcx", "playagainover.pcx", restartwin(),NULL,NULL);
 button(666,488, "quitagainclicked.pcx", "quitagainnormal.pcx", "quitagainover.pcx", quit_program(),NULL,NULL);
 digits (289, 271,6, "Arial#40b", 1, score);
}
//////////////////////////////////
TEXT* acc_wintxt=
{
	layer=4;
	pos_x = 363;
	pos_y =357;
	font= Arial#40b;
	string(acc);
}
//////////////////////////////////////////////////////////////////////Ratings
TEXT* toprating=
{
	layer=4;
	pos_x =319;
	pos_y =442;
	font= Arial#35b;
	string(champion);
}
////////////////////////
TEXT* secondrating=
{
	layer=4;
	pos_x =319;
	pos_y =442;
	font= Arial#35b;
	string(expert);
}
TEXT* thirdrating=
{
	layer =4;
	pos_x =319;
	pos_y =442;
	font =Arial#35b;
	string(great);
}
TEXT* fourthrating=
{
	layer =4;
	pos_x =319;
	pos_y =442;
	font =Arial#35b;
	string(good);
}
TEXT* fifthrating=
{
	layer =4;
	pos_x =319;
	pos_y =442;
	font =Arial#35b;
	string(try);
}
///////////////////////////////
function set_rating()
{ 
 switch(missed)
 {
   case 1:
   secondrating.flags = SHOW;
   break;
   
  case 2:
   secondrating.flags = SHOW;
   break;
   
  case 3:
   thirdrating.flags = SHOW;
   break;
  
  case 4:
   thirdrating.flags = SHOW;
   break;
  
  case 5:
   fourthrating.flags = SHOW;
   break;
  
  case 6:
   fourthrating.flags = SHOW;
   break;
  
  case 7:
   fifthrating.flags = SHOW;
   break;
  
  default:
   toprating.flags= SHOW;
   break;
 }
}
/////////////////////////////
function clear_rating()
{
	toprating.flags = 0;
	secondrating.flags = 0;
	thirdrating.flags = 0;
	fourthrating.flags = 0;
	fifthrating.flags = 0;
}
/////////////////////////////////////////////////////////////////////The levels
BMAP* back1 = "blueswirlystuff.jpg";
PANEL* level_one =
{
	bmap = back1;
	layer = 0;
}
////////////////////////////////////
BMAP* back2 = "coloroverlay.jpg";
PANEL* level_two =
{
	bmap = back2;
	layer = 0;
}
/////////////////////////////////////
BMAP* back3 = "tiles.jpg";
PANEL* level_three =
{
	bmap = back3;
	layer = 0;
}
////////////////////////////////////
BMAP* back4 = "rainbowsplash.jpg";
PANEL* level_four =
{
	bmap = back4;
	layer = 0;
}
////////////////////////////////////
BMAP* back5 = "redtree.jpg";
PANEL* level_five =
{
	bmap = back5;
	layer = 0;
}
////////////////////////////////////
BMAP* back6 = "purplesky.jpg";
PANEL* level_six =
{
	bmap = back6;
	layer = 0;
}
///////////////////////////////////
BMAP* back7 = "greenrobot.jpg";
PANEL* level_seven =
{
	bmap = back7;
	layer = 0;
}
///////////////////////////////////
BMAP* back8 = "creepycool.jpg";
PANEL* level_eight =
{
	bmap = back8;
	layer = 0;
}
///////////////////////////////////
BMAP* back9 = "pipes.jpg";
PANEL* level_nine =
{
	bmap = back9;
	layer = 0;
}
///////////////////////////////////
BMAP* back10 = "zebraseizure.jpg";
PANEL* level_ten =
{
	bmap = back10;
	layer = 0;
}
/////////////////////////////////////////////////////////////////////The blocks
BMAP* block_a = "blocka.pcx";
PANEL* p_blocka = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_a;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_b = "blockb.pcx";
PANEL* p_blockb =
{
	pos_x = 0;
	pos_y = -145;
	layer= 1;
	bmap= block_b;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_c = "blockc.pcx";
PANEL* p_blockc = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_c;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_d = "blockd.pcx";
PANEL* p_blockd = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_d;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_e = "blocke.pcx";
PANEL* p_blocke = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_e;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_f = "blockf.pcx";
PANEL* p_blockf = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_f;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_g = "blockg.pcx";
PANEL* p_blockg = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_g;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_h = "blockh.pcx";
PANEL* p_blockh = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_h;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_i = "blocki.pcx";
PANEL* p_blocki = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_i;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_j = "blockj.pcx";
PANEL* p_blockj = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_j;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_k = "blockk.pcx";
PANEL* p_blockk = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_k;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_l = "blockl.pcx";
PANEL* p_blockl = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_l;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_m = "blockm.pcx";
PANEL* p_blockm = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_m;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_n = "blockn.pcx";
PANEL* p_blockn = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_n;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_o = "blocko.pcx";
PANEL* p_blocko = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_o;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_p = "blockp.pcx";
PANEL* p_blockp = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_p;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_q = "blockq.pcx";
PANEL* p_blockq = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_q;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_r = "blockr.pcx";
PANEL* p_blockr = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_r;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_s = "blocks.pcx";
PANEL* p_blocks = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_s;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_t = "blockt.pcx";
PANEL* p_blockt = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_t;
	flags = SHOW | OVERLAY;
}
//////////////////////////////////////
BMAP* block_u = "blocku.pcx";
PANEL* p_blocku = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_u;
	flags = SHOW | OVERLAY;
}
//////////////////////////////////////
BMAP* block_v = "blockv.pcx";
PANEL* p_blockv = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_v;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_w = "blockw.pcx";
PANEL* p_blockw = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_w;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_x = "blockx.pcx";
PANEL* p_blockx = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_x;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_y = "blocky.pcx";
PANEL* p_blocky = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_y;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_z = "blockz.pcx";
PANEL* p_blockz = 
{
	pos_x = 0;
	pos_y = -145;
	layer = 1;
	bmap = block_z;
	flags = SHOW | OVERLAY;
}
/////////////////////////////////////
BMAP* block_star = "blockstar.pcx";
PANEL* p_blockstar = 
{
	pos_x = 0;
	pos_y = -200;
	layer = 1;
	bmap = block_star;
	flags = SHOW | OVERLAY;
}
////////////////////////////////////////////////////////////////////////The functions
///////////////////////////////////////////////////level changes
function extralife()
{
if(noise ==0){snd_play(freelife,volume +10,0);}
	lives +=1;
}
/////////////////////////////////////////////////////
function dropblock_star()
{
		p_blockstar.pos_x = random(550);
	while (p_blockstar.pos_y < 580)
		{
			p_blockstar.pos_y += (speed*time_step)/2;
			wait(1);
			if(p_blockstar.pos_y>-30 && p_blockstar.pos_y<578 && key_space)
			{
				extralife();
				break;
			}
		}
		p_blockstar.pos_y = -200;
		wait (1);
	}
/////////////////////////////////////
function level_swap2()
{
	level_one.flags =0;
if(images ==0){level_two.flags = SHOW;}
	media_stop(firstmusic);
if(noise ==0){snd_play(levelsignal1,volume +10,0);}
	secondmusic =media_loop("battle_themedw.mid",NULL,volume);
	level = 2;
	speed +=10;
}
///////////////////////////////////
function level_swap3()
{
	level_two.flags =0;
if(images ==0){level_three.flags = SHOW;}
	media_stop(secondmusic);
if(noise ==0){snd_play(levelsignal2,volume +10,0);}
	thirdmusic =media_loop("wbike.mid",NULL,volume);
	level = 3;
	dropblock_star();
	speed +=10;
}
//////////////////////////////////
function level_swap4()
{
	level_three.flags =0;
if(images ==0){level_four.flags = SHOW;}
	media_stop(thirdmusic);
if(noise ==0){snd_play(levelsignal3,volume +10,0);}
	fourthmusic =media_loop("it_can_waver_and_fight.mid",NULL,volume);
	level =4;
	speed +=10;
}
///////////////////////////////////
function level_swap5()
{
	level_four.flags =0;
if(images ==0){level_five.flags = SHOW;}
	media_stop(fourthmusic);
if(noise ==0){snd_play(levelsignal1,volume +10,0);}
	fifthmusic =media_loop("sky_battle.mid", NULL,volume);
	level =5;
	speed +=10;
}
///////////////////////////////////
function level_swap6()
{
	level_five.flags =0;
if(images ==0){level_six.flags = SHOW;}
	media_stop(fifthmusic);
if(noise ==0){snd_play(levelsignal2,volume +10,0);}
	sixthmusic =media_loop("advancing_army.mid",NULL,volume);
	level =6;
	dropblock_star();
	speed +=10;
}
///////////////////////////////////
function level_swap7()
{
	level_six.flags =0;
if(images ==0){level_seven.flags = SHOW;}
	media_stop(sixthmusic);
if(noise ==0){snd_play(levelsignal3,volume +10,0);}
	seventhmusic =media_loop("combat_simulator_menu.mid",NULL,volume);
	level =7;
	speed +=10;
}
///////////////////////////////////
function level_swap8()
{
	level_seven.flags =0;
if(images ==0){level_eight.flags = SHOW;}
	media_stop(seventhmusic);
if(noise ==0){snd_play(levelsignal1,volume +10,0);}
	eighthmusic =media_loop("perfect_timing.mid",NULL,volume);
	level =8;
	speed +=10;
}
///////////////////////////////////
function level_swap9()
{
	level_eight.flags =0;
if(images ==0){level_nine.flags = SHOW;}
	media_stop(eighthmusic);
if(noise ==0){snd_play(levelsignal2,volume +10,0);}
	ninethmusic =media_loop("battle_theme.mid",NULL,volume);
	level =9;
	dropblock_star();
	speed +=10;
}
///////////////////////////////////
function level_swap10()
{
	level_nine.flags =0;
if(images ==0){level_ten.flags = SHOW;}
	media_stop(ninethmusic);
if(noise ==0){snd_play(levelsignal3,volume +10,0);}
	tenthmusic =media_loop("battle_theme_5.mid",NULL,volume);
	level =10;
	speed +=10;
}
function you_win()
{
	level_ten.flags =0;
	first_level.flags =0;
	gameover_win.flags =SHOW | OVERLAY;
	media_stop(tenthmusic);
if(noise ==0){winnermusic =media_play("gamecomplete.mid",NULL,volume);}
	if(correct==0){accuracy = 0;}
   else{accuracy = correct/((correct+missed)/100);}
   str_for_int(acc, accuracy);
   str_cat(acc,"%");
   acc_wintxt.flags = SHOW;
   set_rating();
   level=11;
   
}
///////////////////////////////////
function score_keeper()
{
if(noise ==0){snd_play(blockcorrect,90,0);}
	score +=10;
	correct+=1;
	if(correct==10){level_swap2();}
	if(correct==25){level_swap3();}
	if(correct==45){level_swap4();}
	if(correct==70){level_swap5();}
	if(correct==100){level_swap6();}
	if(correct==135){level_swap7();}
	if(correct==175){level_swap8();}
	if(correct==220){level_swap9();}
   if(correct==270){level_swap10();}
   if(correct==325){you_win();}
}
////////////////////////////////////
function missed_block()
{
if(noise ==0){snd_play(blockskip,volume +10,0);}
	lives -=1;
	missed +=1;
	score -=5;
}
function wrong_key()
{
if(noise ==0){snd_play(blockmiss,volume +10,0);}
	missed +=1;
	lives -=1;
	score -=2;
}
//////////////////////////////////////////////////block maintinance 
function dropblock_a()
{
		p_blocka.pos_x = random(559);
	while (p_blocka.pos_y < 580)
		{
			p_blocka.pos_y += speed*time_step;
			wait(5);
			if(p_blocka.pos_y>-50 && p_blocka.pos_y<578 && key_a)
			{ score_keeper();
			  break;
			}
			if(key_any && key_a !=1 && p_blocka.pos_y>1 && p_blocka.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocka.pos_y>579){missed_block();}
		}
		p_blocka.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_b()
{
		p_blockb.pos_x = random(559);
	while (p_blockb.pos_y < 580)
		{
			p_blockb.pos_y += speed*time_step;
			wait(5);
			if(p_blockb.pos_y-50 && p_blockb.pos_y<578 && key_b)
			{ score_keeper();
			  break;
			}
			if(key_any && key_b !=1 && p_blockb.pos_y>1 && p_blockb.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockb.pos_y>579){missed_block();}
		}
		p_blockb.pos_y = -145;
		wait (1);
		roller =1;
	}
///////////////////////////////////
function dropblock_c()
{
		p_blockc.pos_x = random(559);
	while (p_blockc.pos_y < 580)
		{
			p_blockc.pos_y += speed*time_step;
			wait(5);
			if(p_blockc.pos_y>-50 && p_blockc.pos_y<578 && key_c)
			{ score_keeper();
			  break;
			}
			if(key_any && key_c !=1 && p_blockc.pos_y>1 && p_blockc.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockc.pos_y>579){missed_block();}
		}
		p_blockc.pos_y = -145;
		wait (1);
		roller =1;
	}
	///////////////////////////////////
function dropblock_d()
{
		p_blockd.pos_x = random(559);
	while (p_blockd.pos_y < 580)
		{
			p_blockd.pos_y += speed*time_step;
			wait(5);
			if(p_blockd.pos_y>-50 && p_blockd.pos_y<578 && key_d)
			{ score_keeper();
			  break;
			}
			if(key_any && key_d !=1 && p_blockd.pos_y>1 && p_blockd.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockd.pos_y>579){missed_block();}
		}
		p_blockd.pos_y = -145;
		wait (1);
		roller =1;
	}
	/////////////////////////////////////
function dropblock_e()
{
		p_blocke.pos_x = random(559);
	while (p_blocke.pos_y < 580)
		{
			p_blocke.pos_y += speed*time_step;
			wait(5);
			if(p_blocke.pos_y>-50 && p_blocke.pos_y<578 && key_e)
			{ score_keeper();
			  break;
			}
			if(key_any && key_e !=1 && p_blocke.pos_y>1 && p_blocke.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocke.pos_y>579){missed_block();}
		}
		p_blocke.pos_y = -145;
		wait (1);
		roller =1;
	}
	///////////////////////////////////
	function dropblock_f()
{
		p_blockf.pos_x = random(559);
	while (p_blockf.pos_y < 580)
		{
			p_blockf.pos_y += speed*time_step;
			wait(5);
			if(p_blockf.pos_y>-50 && p_blockf.pos_y<578 && key_f)
			{ score_keeper();
			  break;
			}
			if(key_any && key_f !=1 && p_blockf.pos_y>1 && p_blockf.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockf.pos_y>579){missed_block();}
		}
		p_blockf.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_g()
{
		p_blockg.pos_x = random(559);
	while (p_blockg.pos_y < 580)
		{
			p_blockg.pos_y += speed*time_step;
			wait(5);
			if(p_blockg.pos_y>-50 && p_blockg.pos_y<578 && key_g)
			{ score_keeper();
			  break;
			}
			if(key_any && key_g !=1 && p_blockg.pos_y>1 && p_blockg.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockg.pos_y>579){missed_block();}
		}
		p_blockg.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_h()
{
		p_blockh.pos_x = random(559);
	while (p_blockh.pos_y < 580)
		{
			p_blockh.pos_y += speed*time_step;
			wait(5);
			if(p_blockh.pos_y>-50 && p_blockh.pos_y<578 && key_h)
			{ score_keeper();
			  break;
			}
			if(key_any && key_h !=1 && p_blockh.pos_y>1 && p_blockh.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockh.pos_y>579){missed_block();}
		}
		p_blockh.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_i()
{
		p_blocki.pos_x = random(559);
	while (p_blocki.pos_y < 580)
		{
			p_blocki.pos_y += speed*time_step;
			wait(5);
			if(p_blocki.pos_y>-50 && p_blocki.pos_y<578 && key_i)
			{ score_keeper();
			  break;
			}
			if(key_any && key_i !=1 && p_blocki.pos_y>1 && p_blocki.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocki.pos_y>579){missed_block();}
		}
		p_blocki.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_j()
{
		p_blockj.pos_x = random(559);
	while (p_blockj.pos_y < 580)
		{
			p_blockj.pos_y += speed*time_step;
			wait(5);
			if(p_blockj.pos_y>-50 && p_blockj.pos_y<578 && key_j)
			{ score_keeper();
			  break;
			}
			if(key_any && key_j !=1 && p_blockj.pos_y>1 && p_blockj.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockj.pos_y>579){missed_block();}
		}
		p_blockj.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_k()
{
		p_blockk.pos_x = random(559);
	while (p_blockk.pos_y < 580)
		{
			p_blockk.pos_y += speed*time_step;
			wait(5);
			if(p_blockk.pos_y>-50 && p_blockk.pos_y<578 && key_k)
			{ score_keeper();
			  break;
			}
			if(key_any && key_k !=1 && p_blockk.pos_y>1 && p_blockk.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockk.pos_y>579){missed_block();}
		}
		p_blockk.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_l()
{
		p_blockl.pos_x = random(559);
	while (p_blockl.pos_y < 580)
		{
			p_blockl.pos_y += speed*time_step;
			wait(5);
			if(p_blockl.pos_y>-50 && p_blockl.pos_y<578 && key_l)
			{ score_keeper();
			  break;
			}
			if(key_any && key_l !=1 && p_blockl.pos_y>1 && p_blockl.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockl.pos_y>579){missed_block();}
		}
		p_blockl.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_m()
{
		p_blockm.pos_x = random(559);
	while (p_blockm.pos_y < 580)
		{
			p_blockm.pos_y += speed*time_step;
			wait(5);
			if(p_blockm.pos_y>-50 && p_blockm.pos_y<578 && key_m)
			{ score_keeper();
			 break;
			}
			if(key_any && key_m !=1 && p_blockm.pos_y>1 && p_blockm.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockm.pos_y>579){missed_block();}
		}
		p_blockm.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_n()
{
		p_blockn.pos_x = random(559);
	while (p_blockn.pos_y < 580)
		{
			p_blockn.pos_y += speed*time_step;
			wait(5);
			if(p_blockn.pos_y>-50 && p_blockn.pos_y<578 && key_n)
			{ score_keeper();
			 break;
			}
			if(key_any && key_n !=1 && p_blockn.pos_y>1 && p_blockn.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockn.pos_y>579){missed_block();}
		}
		p_blockn.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_o()
{
		p_blocko.pos_x = random(559);
	while (p_blocko.pos_y < 580)
		{
			p_blocko.pos_y += speed*time_step;
			wait(5);
			if(p_blocko.pos_y>-50 && p_blocko.pos_y<578 && key_o)
			{ score_keeper();
			 break;
			}
			if(key_any && key_o !=1 && p_blocko.pos_y>1 && p_blocko.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocko.pos_y>579){missed_block();}
		}
		p_blocko.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_p()
{
		p_blockp.pos_x = random(559);
	while (p_blockp.pos_y < 580)
		{
			p_blockp.pos_y += speed*time_step;
			wait(5);
			if(p_blockp.pos_y>-50 && p_blockp.pos_y<578 && key_p)
			{ score_keeper();
			 break;
			}
			if(key_any && key_p !=1 && p_blockp.pos_y>1 && p_blockp.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockp.pos_y>579){missed_block();}
		}
		p_blockp.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_q()
{
		p_blockq.pos_x = random(559);
	while (p_blockq.pos_y < 580)
		{
			p_blockq.pos_y += speed*time_step;
			wait(5);
			if(p_blockq.pos_y>-70 && p_blockq.pos_y<578 && key_q)
			{ score_keeper();
			 break;
			}
			if(key_any && key_q !=1 && p_blockq.pos_y>1 && p_blockq.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockq.pos_y>579){missed_block();}
		}
		p_blockq.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_r()
{
		p_blockr.pos_x = random(559);
	while (p_blockr.pos_y < 580)
		{
			p_blockr.pos_y += speed*time_step;
			wait(5);
			if(p_blockr.pos_y>-50 && p_blockr.pos_y<578 && key_r)
			{ score_keeper();
			 break;
			}
			if(key_any && key_r !=1 && p_blockr.pos_y>1 && p_blockr.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockr.pos_y>579){missed_block();}
		}
		p_blockr.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_s()
{
		p_blocks.pos_x = random(559);
	while (p_blocks.pos_y < 580)
		{
			p_blocks.pos_y += speed*time_step;
			wait(5);
			if(p_blocks.pos_y>-50 && p_blocks.pos_y<578 && key_s)
			{ score_keeper();
			 break;
			}
			if(key_any && key_s !=1 && p_blocks.pos_y>1 && p_blocks.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocks.pos_y>579){missed_block();}
		}
		p_blocks.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_t()
{
		p_blockt.pos_x = random(559);
	while (p_blockt.pos_y < 580)
		{
			p_blockt.pos_y += speed*time_step;
			wait(5);
			if(p_blockt.pos_y>-50 && p_blockt.pos_y<578 && key_t)
			{ score_keeper();
			 break;
			}
			if(key_any && key_t !=1 && p_blockt.pos_y>1 && p_blockt.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockt.pos_y>579){missed_block();}
		}
		p_blockt.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_u()
{
		p_blocku.pos_x = random(559);
	while (p_blocku.pos_y < 580)
		{
			p_blocku.pos_y += speed*time_step;
			wait(5);
			if(p_blocku.pos_y>-50 && p_blocku.pos_y<578 && key_u)
			{ score_keeper();
			 break;
			}
			if(key_any && key_u !=1 && p_blocku.pos_y>1 && p_blocku.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocku.pos_y>579){missed_block();}
		}
		p_blocku.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_v()
{
		p_blockv.pos_x = random(559);
	while (p_blockv.pos_y < 580)
		{
			p_blockv.pos_y += speed*time_step;
			wait(5);
			if(p_blockv.pos_y>-50 && p_blockv.pos_y<578 && key_v)
			{ score_keeper();
			 break;
			}
			if(key_any && key_v !=1 && p_blockv.pos_y>1 && p_blockv.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockv.pos_y>579){missed_block();}
		}
		p_blockv.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_w()
{
		p_blockw.pos_x = random(559);
	while (p_blockw.pos_y < 580)
		{
			p_blockw.pos_y += speed*time_step;
			wait(5);
			if(p_blockw.pos_y>-50 && p_blockw.pos_y<578 && key_w)
			{ score_keeper();
			 break;
			}
			if(key_any && key_w !=1 && p_blockw.pos_y>1 && p_blockw.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockw.pos_y>579){missed_block();}
		}
		p_blockw.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_x()
{
		p_blockx.pos_x = random(559);
	while (p_blockx.pos_y < 580)
		{
			p_blockx.pos_y += speed*time_step;
			wait(5);
			if(p_blockx.pos_y>-50 && p_blockx.pos_y<578 && key_x)
			{ score_keeper();
			 break;
			}
			if(key_any && key_x !=1 && p_blockx.pos_y>1 && p_blockx.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockx.pos_y>579){missed_block();}
		}
		p_blockx.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_y()
{
		p_blocky.pos_x = random(559);
	while (p_blocky.pos_y < 580)
		{
			p_blocky.pos_y += speed*time_step;
			wait(5);
			if(p_blocky.pos_y>-50 && p_blocky.pos_y<578 && key_y)
			{ score_keeper();
			 break;
			}
			if(key_any && key_y !=1 && p_blocky.pos_y>1 && p_blocky.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blocky.pos_y>579){missed_block();}
		}
		p_blocky.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
function dropblock_z()
{
		p_blockz.pos_x = random(559);
	while (p_blockz.pos_y < 580)
		{
			p_blockz.pos_y += speed*time_step;
			wait(5);
			if(p_blockz.pos_y>-50 && p_blockz.pos_y<578 && key_z)
			{ score_keeper();
			 break;
			}
			if(key_any && key_z !=1 && p_blockz.pos_y>1 && p_blockz.pos_y<578)
			{wrong_key();
			 break;
			}
			if(p_blockz.pos_y>579){missed_block();}
		}
		p_blockz.pos_y = -145;
		wait (1);
		roller =1;
	}
/////////////////////////////////////
	function pickpanel()
{
	switch(dice)
	{
		case 1:
		dropblock_a();
		break;
		case 2:
		dropblock_b();
		break;
		case 3:
		dropblock_c();
		break;
		case 4:
		dropblock_d();
		break;
		case 5:
		dropblock_e();
		break;
		case 6:
		dropblock_f();
		break;
		case 7:
		dropblock_g();
		break;
		case 8:
		dropblock_h();
		break;
		case 9:
		dropblock_i();
		break;
		case 10:
		dropblock_j();
		break;
		case 11:
		dropblock_k();
		break;
		case 12:
		dropblock_l();
		break;
		case 13:
		dropblock_m();
		break;
		case 14:
		dropblock_n();
		break;
		case 15:
		dropblock_o();
		break;
		case 16:
		dropblock_p();
		break;
		case 17:
		dropblock_q();
		break;
		case 18:
		dropblock_r();
		break;
		case 19:
		dropblock_s();
		break;
		case 20:
		dropblock_t();
		break;
		case 21:
		dropblock_u();
		break;
		case 22:
		dropblock_v();
		break;
		case 23:
		dropblock_w();
		break;
		case 24:
		dropblock_x();
		break;
		case 25:
		dropblock_y();
		break;
		case 26:
		dropblock_z();
		break;
	}
}
///////////////////////////////////////////////system business
function clear_background()
{
	level_two.flags =0;
	level_three.flags =0;
	level_four.flags =0;
	level_five.flags =0;
	level_six.flags =0;
	level_seven.flags =0;
	level_eight.flags =0;
	level_nine.flags =0;
	level_ten.flags =0;
}
function quiet()
{
   media_stop(firstmusic);
	media_stop(secondmusic);
	media_stop(thirdmusic);
	media_stop(fourthmusic);
	media_stop(fifthmusic);
	media_stop(sixthmusic);
	media_stop(seventhmusic);
	media_stop(eighthmusic);
	media_stop(ninethmusic);
	media_stop(tenthmusic);
}
//////////////////////////////////////
function done()
{
	if(correct==0){accuracy = 0;}
   else{accuracy = correct/((correct+missed)/100);}
   str_for_int(acc, accuracy);
   str_cat(acc,"%");
   first_level.flags = 0;
   clear_background();
	final_screen.flags = SHOW | OVERLAY;
	quiet();
if(noise ==0){losermusic = media_play("gameover.mid",NULL, volume);}
	acc_txt.flags = SHOW;
	roller = 0;
}
///////////////////////////////////////
function rolldice()
{
	while (1)
		{
			if(lives==0)
			{
			   done();
			   break;
			}
			if(level==11)
			{
				break;
			}
			if(roller==1 && p_blockstar.pos_y == -200)
			{
				dice = random (25)+1;
				dice =integer(dice);	
				roller = 0;
				wait (1);
				pickpanel();
			   wait(1);
			}
			wait(1);
   	}
}
function restartlose()
{
	final_screen.flags=0;
	acc_txt.flags = 0;
	wait(1);
	intro2.flags = SHOW | OVERLAY;
	intromusic =media_loop("steel_samurai_ringtone.mid",NULL, volume);
	button_state(intro2,5,ON);
	lives =3;
	speed =50;
	level =1;
	score =0;
	correct =0;
	missed =0;
}
/////////////////////////////////////
function restartwin()
{
	gameover_win.flags =0;
	acc_wintxt.flags = 0;
	clear_rating();
	wait(1);
	intro2.flags = SHOW | OVERLAY;
	intromusic =media_loop("steel_samurai_ringtone.mid",NULL, volume);
	button_state(intro2,5,ON);
	lives =3;
	speed =50;
	level =1;
	score =0;
	correct =0;
	missed =0;
}
///////////////////////////////////////////////////////////The control
function gamestart()
{
	random_seed (0);
	roller =1;
	rolldice();
	intro2.flags = 0;
	gameoptions1.flags = 0;
	media_stop(intromusic);
	firstmusic =media_loop("munchies.mid",NULL,volume);
if(images ==0){level_one.flags= SHOW | OVERLAY;}
	first_level.flags= SHOW | OVERLAY; 
}
////////////////////////////////////
function main()
{
	video_set(800,600,0,2);
	mouse_mode = 4;
	wait(4);
	intromusic =media_loop("steel_samurai_ringtone.mid",NULL, volume);
	wait (-4);
	intro1.flags = 0;
	intro2.flags = SHOW | OVERLAY;
   button_state(intro2,5,ON);
}